Attribute VB_Name = "mMsgBoxEx"
Option Compare Database
'---------------------------------------------------------
'
' MsgBoxEx
'
' Cdigo escrito originalmente por Juan M Afn de Ribera.
' Ests autorizado a utilizarlo dentro de una aplicacin
' siempre que esta nota de autor permanezca inalterada.
' En el caso de querer publicarlo en una pgina Web,
' por favor, contactar con el autor en
'
'     accessvbafaq@ya.com
'
' Este cdigo se brinda por cortesa de
' Juan M. Afn de Ribera
'
'
' Funcin que establece el texto de una ventana
Private Declare Function SetWindowText Lib "user32" _
                Alias "SetWindowTextA" _
                (ByVal hwnd As Long, _
                ByVal lpString As String) As Long

' Funcin que devuelve el manipulador de una ventana
Private Declare Function GetWindow Lib "user32" _
                (ByVal hwnd As Long, _
                ByVal wCmd As Long) As Long
                
' Funcin que devuelve el nombre de clase de una ventana
Private Declare Function GetClassName Lib "user32" _
                Alias "GetClassNameA" _
                (ByVal hwnd As Long, _
                ByVal lpClassName As String, _
                ByVal nMaxCount As Long) As Long
                
' Funcin que devuelve el ID del control de un cuadro de dilogo
Private Declare Function GetDlgCtrlID Lib "user32" _
                (ByVal hwnd As Long) As Long
                
' Funcin que enva un mensaje al control de un cuadro de dilogo
Private Declare Function SendDlgItemMessage Lib "user32" _
                Alias "SendDlgItemMessageA" _
                (ByVal hDlg As Long, _
                ByVal nIDDlgItem As Long, _
                ByVal wMsg As Long, _
                ByVal wParam As Long, _
                ByVal lParam As Any) As Long
                
' Funcin que devuelve el manipulador de una imagen
Private Declare Function LoadImage Lib "user32" _
                Alias "LoadImageA" _
                (ByVal hInst As Long, _
                ByVal lpsz As String, _
                ByVal un1 As Long, _
                ByVal n1 As Long, _
                ByVal n2 As Long, _
                ByVal un2 As Long) As Long
                
' Funcin que enva un mensaje a una ventana
Private Declare Function SendMessage Lib "user32" _
                Alias "SendMessageA" _
                (ByVal hwnd As Long, _
                ByVal wMsg As Long, _
                ByVal wParam As Long, _
                lParam As Any) As Long
                
' Funcin que devuelve el manipulador de la ventana activa en ese momento
Private Declare Function GetForegroundWindow Lib "user32" () As Long

' Funcin que devuelve informacin de una ventana
Private Declare Function GetWindowLong Lib "user32" _
                Alias "GetWindowLongA" _
                (ByVal hwnd As Long, _
                ByVal nIndex As Long) As Long
                
' Funcin que crea un Timer de sistema
Private Declare Function SetTimer Lib "user32" _
                (ByVal hwnd As Long, _
                ByVal nIDEvent As Long, _
                ByVal uElapse As Long, _
                ByVal lpTimerFunc As Long) As Long
                
' Funcin que destruye un timer de sistema
Private Declare Function KillTimer Lib "user32" _
                (ByVal hwnd As Long, _
                ByVal nIDEvent As Long) As Long

' constante para escribir un texto
Private Const WM_SETTEXT = &HC
' constante para establecer un icono
Private Const WM_SETICON = &H80
' constante para establecer la imagen de un control Static
Private Const STM_SETIMAGE = &H172
' constante que indica que se llama a una imagen tipo icono
Private Const IMAGE_ICON = 1
' constante que indica que la imagen proviene de un fichero
Private Const LR_LOADFROMFILE = &H10
' constante para llamar a una ventana hija
Private Const GW_CHILD = 5&
' constante para llamar a la siguiente ventana
Private Const GW_HWNDNEXT = 2&
' constante de estilo para poder contener un icono
Private Const SS_ICON = &H3&
' constante para devolver informacin del estilo de una ventana
Private Const GWL_STYLE = (-16)

' variables globales de MsgBoxEx
Private hMsgBox As Long
Private hIconWindow As Long
Private hIconBar As Long
Private Title2 As String
Private ButtonsText(1 To 7) As String
Private Tm As Long

Public Function MsgBoxEx( _
                        Prompt, _
                        Optional buttons As VbMsgBoxStyle, _
                        Optional Title, _
                        Optional HelpFile, _
                        Optional Context, _
                        Optional IconBar As String, _
                        Optional IconWindow As String, _
                        Optional BtOk As String, _
                        Optional BtCancel As String, _
                        Optional BtAbort As String, _
                        Optional BtRetry As String, _
                        Optional BtIgnore As String, _
                        Optional BtYes As String, _
                        Optional BtNo As String) As VbMsgBoxResult
    
    If hMsgBox = 0 Then
        ButtonsText(1) = BtOk ' Texto botn Ok - IDControl = vbOk = 1
        ButtonsText(2) = BtCancel ' Texto botn Cancelar/Aceptar - IDControl = vbCancel = 2
        ButtonsText(3) = BtAbort ' Texto botn Anular - IDControl = vbAbort = 3
        ButtonsText(4) = BtRetry ' Texto botn Reintentar - IDControl = vbRetry = 4
        ButtonsText(5) = BtIgnore ' Texto botn Ignorar - IDControl = vbIgnore = 5
        ButtonsText(6) = BtYes ' Texto botn S - IDControl = vbYes = 6
        ButtonsText(7) = BtNo ' Texto botn No - IDControl = vbNo = 7
             
        ' si se ha indicado un icono para la barra de ttulo
        If IconBar <> "" Then
            ' se obtiene un manipulador de la imagen
            hIconBar = hIcon(IconBar, 16&)
            ' aadimos unos cuantos blancos para hacer sitio
            ' en la barra de ttulo para el icono, pues el
            ' MsgBox no est originalmente preparado para ello
            Title2 = Title
            Title = Title & String(6, Chr(32))
        Else
            ' si no, ponemos posibles valores anteriores de hIconBar a 0
            hIconBar = 0
        End If
        
        ' necesitamos comprobar que se puede cargar la imagen
        ' correspondiente a la ventana cliente del MsgBox, para
        ' configurar el espacio correspondiente al icono. Si la
        ' ruta fuera incorrecta y no se comprobara, quedara un
        ' espacio en blanco correspondiente al control Static
        ' que contiene estos iconos.
        
        If IconWindow <> "" Then
            hIconWindow = hIcon(IconWindow, 32&)
            ' si se ha podido cargar la imagen, anulamos cualquier
            ' llamada del usuario a los iconos de mensaje
            ' predeterminados ...
            If hIconWindow Then
                If (buttons And vbCritical) = vbCritical Then
                    buttons = buttons - vbCritical
                ElseIf (buttons And vbExclamation) = vbExclamation Then
                    buttons = buttons - vbExclamation
                ElseIf (buttons And vbInformation) = vbInformation Then
                    buttons = buttons - vbInformation
                ElseIf (buttons And vbQuestion) = vbQuestion Then
                    buttons = buttons - vbQuestion
                End If
                ' y ponemos nosotros uno cualquiera de ellos.
                ' De esta manera aseguramos que existir un control
                ' Static para contener nuestro icono/imagen personalizado.
                buttons = buttons + vbCritical
            End If
        Else
            hIconWindow = 0
        End If
        
        ' Creamos un timer que se ejecutar a la dcima de segundo
        Tm = SetTimer(0&, 0&, 10, AddressOf TimerProc)
        ' llamamos al MsgBox de manera normal
        On Error GoTo AnularTimer
        ' llamamos al MsgBox de VBA con los parmetros normales
        MsgBoxEx = MsgBox(Prompt, buttons, Title, HelpFile, Context)
    End If
    
    Exit Function
        
AnularTimer:
        ' si ha habido algn error, se cancela la operacin
        Call KillTimer(0&, Tm)
        MsgBox "Error: " & Err.Number & vbCrLf & Err.Description

End Function

' Esta funcin se ejecutar una dcima de segundo despus de llamar
' al MsgBox (en modo asncrono) y "capturar" el cuadro de dilogo
' y sus controles para poder manipularlos
'
Private Sub TimerProc( _
                     ByVal hwnd As Long, _
                     ByVal uMsg As Long, _
                     ByVal idEvent As Long, _
                     ByVal dwTime As Long)
    
Dim cnt As Long

    ' capturamos el manipulador del MsgBox
    hMsgBox = GetForegroundWindow
    
    ' si se ha indicado un icono para la barra de ttulo
    If hIconBar Then
        ' se carga
        Call SendMessage(hMsgBox, WM_SETICON, 0&, ByVal hIconBar)
        Call SetWindowText(hMsgBox, Title2)
    End If
      
    ' si se ha indicado un icono para la ventana de cliente
    If hIconWindow Then
        ' se carga - CtrlId devolver el ID del control que contiene el icono
        Call SendDlgItemMessage(hMsgBox, CtrlId, STM_SETIMAGE, IMAGE_ICON, hIconWindow)
    End If
       
    ' ponemos el texto a los botones (si lo hay)
    For cnt = 1 To 7
        ' si se ha indicado un texto para alguno de los botones
        If ButtonsText(cnt) <> "" Then
            ' se cambia su texto.
            ' cnt = nmero de ID de control de cada uno de los botones
            ' dentro del cuadro de dilogo
            Call SendDlgItemMessage(hMsgBox, cnt, WM_SETTEXT, 0&, ButtonsText(cnt))
        End If
    Next
    
    ' anulamos el timer, ya que slo se ejecutar una vez (de momento)
    Call KillTimer(0&, Tm)
    hMsgBox = 0
    
End Sub

' funcin que devuelve el manipulador de una imagen
' para este cdigo me he basado en el ejemplo que amablemente proporciona
' Klaus Probst en http://www.mvps.org/access/api/api0043.htm
'
Function hIcon(IconPath As String, IconSize As Long) As Long
    hIcon = LoadImage(0&, IconPath, IMAGE_ICON, IconSize, IconSize, LR_LOADFROMFILE)
End Function

' Esta funcin devuelve el ID del control Static que contiene los iconos
' de la ventana cliente del MsgBox.
' El ID de este control, junto con el ID del control Static que contiene
' el texto del MsgBox vara entre versiones, tanto de Access como del sistema
' operativo, as que he tenido que crear una funcin que lo localizara.
' Se le puede localizar, primero por el tipo de control (Static) y
' despus por el estilo SS_ICON, que es un estilo (atributo) que permite al
' control contener un icono y expandirse segn su tamao
'
Function CtrlId() As Long
Dim buffer As String * 100
Dim hwnd As Long
Dim CurStyle As Long

    ' obtenemos la primera ventana hija del MsgBox
    hwnd = GetWindow(hMsgBox, GW_CHILD)
    Do While hwnd
        ' obtenemos el nombre de la clase de ventana
        GetClassName hwnd, buffer, 100
        ' si es de la clase Static
        If UCase(Left(buffer, 6)) = "STATIC" Then
            CurStyle = GetWindowLong(hwnd, GWL_STYLE)
            ' si tiene el estilo SS_ICON
            If (CurStyle And SS_ICON) = SS_ICON Then
                ' obtenemos el nmero de ID del control
                CtrlId = GetDlgCtrlID(hwnd)
                Exit Function
            End If
        End If
        hwnd = GetWindow(hwnd, GW_HWNDNEXT)
    Loop
    
End Function
'---------------------------------------------------------

